Package org.apache.commons.jxpath.ri.model.beans

# Class PropertyPointer

java.lang.Object
org.apache.commons.jxpath.ri.model.NodePointer
org.apache.commons.jxpath.ri.model.beans.PropertyPointer

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable`, `Pointer`

Direct Known Subclasses:
  `BeanPropertyPointer`, `DynaBeanPropertyPointer`, `DynamicPropertyPointer`, `NullPropertyPointer`

public abstract class PropertyPointer extends NodePointer
A pointer allocated by a PropertyOwnerPointer to represent the value of a property of the parent object.

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected Object`
  `bean`
  Owning object
  `protected int`
  `propertyIndex`
  Property index
  `static final int`
  `UNSPECIFIED_PROPERTY`
  Marks a property as unspecified.

  ### Fields inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `index, locale, parent, UNKNOWN_NAMESPACE, WHOLE_COLLECTION`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PropertyPointer(NodePointer parent)`
  Takes a JavaBean, a descriptor of a property of that object and an offset within that property (starting with 0).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareChildNodePointers(NodePointer pointer1, NodePointer pointer2)`
  Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.
  `NodePointer`
  `createChild(JXPathContext context, QName qName, int index)`
  Called by a child pointer when it needs to create a parent object for a non-existent collection element.
  `NodePointer`
  `createChild(JXPathContext context, QName qName, int index, Object value)`
  Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node.
  `NodePointer`
  `createPath(JXPathContext context)`
  Called by a child pointer when it needs to create a parent object.
  `NodePointer`
  `createPath(JXPathContext context, Object value)`
  Called directly by JXPathContext.
  `boolean`
  `equals(Object object)`
  `Object`
  `getBean()`
  Gets the parent bean.
  `Object`
  `getImmediateNode()`
  Returns the object the pointer points to; does not convert it to a "canonical" type.
  `NodePointer`
  `getImmediateValuePointer()`
  Returns a NodePointer that can be used to access the currently selected property value.
  `int`
  `getLength()`
  If the property contains a collection, then the length of that collection, otherwise - 1.
  `QName`
  `getName()`
  Gets the name of this node.
  `abstract int`
  `getPropertyCount()`
  Count the number of properties represented.
  `int`
  `getPropertyIndex()`
  Gets the property index.
  `abstract String`
  `getPropertyName()`
  Gets the property name.
  `abstract String[]`
  `getPropertyNames()`
  Gets the names of the included properties.
  `int`
  `hashCode()`
  `boolean`
  `isActual()`
  An actual pointer points to an existing part of an object graph, even if it is null.
  `protected abstract boolean`
  `isActualProperty()`
  Tests whether this pointer references an actual property.
  `boolean`
  `isCollection()`
  Returns `true` if the value of the pointer is an array or a Collection.
  `boolean`
  `isLeaf()`
  If true, this node does not have children
  `void`
  `setPropertyIndex(int index)`
  Sets the property index.
  `abstract void`
  `setPropertyName(String propertyName)`
  Sets the property name.

  ### Methods inherited from class org.apache.commons.jxpath.ri.model.NodePointer

  `asPath, attributeIterator, childIterator, clone, compareTo, createAttribute, escape, getAbstractFactory, getBaseValue, getDefaultNamespaceURI, getImmediateParentPointer, getIndex, getLocale, getNamespaceResolver, getNamespaceURI, getNamespaceURI, getNode, getNodeSetByKey, getNodeValue, getParent, getPointerByID, getPointerByKey, getRootNode, getValue, getValuePointer, handle, handle, isAttribute, isContainer, isDefaultNamespace, isLanguage, isNode, isRoot, namespaceIterator, namespacePointer, newChildNodePointer, newNodePointer, printPointerChain, remove, setAttribute, setExceptionHandler, setIndex, setNamespaceResolver, setValue, testNode, toString, verify`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### UNSPECIFIED_PROPERTY

    public static final int UNSPECIFIED_PROPERTY
    Marks a property as unspecified.
    See Also:
      - Constant Field Values

  - ### propertyIndex

    protected int propertyIndex
    Property index

  - ### bean

    protected Object bean
    Owning object

- ## Constructor Details

  - ### PropertyPointer

    public PropertyPointer(NodePointer parent)
    Takes a JavaBean, a descriptor of a property of that object and an offset within that property (starting with 0).
    Parameters:
      `parent` - parent pointer

- ## Method Details

  - ### compareChildNodePointers

    public int compareChildNodePointers(NodePointer pointer1, NodePointer pointer2)
    Description copied from class: `NodePointer`
    Compares two child NodePointers and returns a positive number, zero or a positive number according to the order of the pointers.
    Specified by:
      `compareChildNodePointers` in class `NodePointer`
    Parameters:
      `pointer1` - first pointer to be compared
      `pointer2` - second pointer to be compared
    Returns:
      int per Java comparison conventions

  - ### createChild

    public NodePointer createChild(JXPathContext context, QName qName, int index)
    Description copied from class: `NodePointer`
    Called by a child pointer when it needs to create a parent object for a non-existent collection element. It may have to expand the collection, then create an element object and return a new pointer describing the newly created element.
    Overrides:
      `createChild` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathCOntext
      `qName` - the QName at which a child should be created
      `index` - child index.
    Returns:
      created NodePointer

  - ### createChild

    public NodePointer createChild(JXPathContext context, QName qName, int index, Object value)
    Description copied from class: `NodePointer`
    Called by a child pointer if that child needs to assign the value supplied in the createPath(context, value) call to a non-existent node. This method may have to expand the collection in order to assign the element.
    Overrides:
      `createChild` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathCOntext
      `qName` - the QName at which a child should be created
      `index` - child index.
      `value` - node value to set
    Returns:
      created NodePointer

  - ### createPath

    public NodePointer createPath(JXPathContext context)
    Description copied from class: `NodePointer`
    Called by a child pointer when it needs to create a parent object. Must create an object described by this pointer and return a new pointer that properly describes the new object.
    Overrides:
      `createPath` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathContext
    Returns:
      created NodePointer

  - ### createPath

    public NodePointer createPath(JXPathContext context, Object value)
    Description copied from class: `NodePointer`
    Called directly by JXPathContext. Must create path and set value.
    Overrides:
      `createPath` in class `NodePointer`
    Parameters:
      `context` - the owning JXPathContext
      `value` - the new value to set
    Returns:
      created NodePointer

  - ### equals

    public boolean equals(Object object)
    Overrides:
      `equals` in class `Object`

  - ### getBean

    public Object getBean()
    Gets the parent bean.
    Returns:
      Object

  - ### getImmediateNode

    public Object getImmediateNode()
    Description copied from class: `NodePointer`
    Returns the object the pointer points to; does not convert it to a "canonical" type.
    Specified by:
      `getImmediateNode` in class `NodePointer`
    Returns:
      Object node

  - ### getImmediateValuePointer

    public NodePointer getImmediateValuePointer()
    Returns a NodePointer that can be used to access the currently selected property value.
    Overrides:
      `getImmediateValuePointer` in class `NodePointer`
    Returns:
      NodePointer
    See Also:
      - `NodePointer.getValuePointer()`

  - ### getLength

    public int getLength()
    If the property contains a collection, then the length of that collection, otherwise - 1.
    Specified by:
      `getLength` in class `NodePointer`
    Returns:
      int length

  - ### getName

    public QName getName()
    Description copied from class: `NodePointer`
    Gets the name of this node. Can be null.
    Specified by:
      `getName` in class `NodePointer`
    Returns:
      QName The name of this node. Can be null.

  - ### getPropertyCount

    public abstract int getPropertyCount()
    Count the number of properties represented.
    Returns:
      int

  - ### getPropertyIndex

    public int getPropertyIndex()
    Gets the property index.
    Returns:
      int index

  - ### getPropertyName

    public abstract String getPropertyName()
    Gets the property name.
    Returns:
      String property name.

  - ### getPropertyNames

    public abstract String[] getPropertyNames()
    Gets the names of the included properties.
    Returns:
      String[]

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### isActual

    public boolean isActual()
    Description copied from class: `NodePointer`
    An actual pointer points to an existing part of an object graph, even if it is null. A non-actual pointer represents a part that does not exist at all. For instance consider the pointer "/address/street". If both address and street are not null, the pointer is actual. If address is not null, but street is null, the pointer is still actual. If address is null, the pointer is not actual. (In JavaBeans) if address is not a property of the root bean, a Pointer for this path cannot be obtained at all - actual or otherwise.
    Overrides:
      `isActual` in class `NodePointer`
    Returns:
      boolean

  - ### isActualProperty

    protected abstract boolean isActualProperty()
    Tests whether this pointer references an actual property.
    Returns:
      true if actual

  - ### isCollection

    public boolean isCollection()
    Description copied from class: `NodePointer`
    Returns `true` if the value of the pointer is an array or a Collection.
    Specified by:
      `isCollection` in class `NodePointer`
    Returns:
      boolean

  - ### isLeaf

    public boolean isLeaf()
    Description copied from class: `NodePointer`
    If true, this node does not have children
    Specified by:
      `isLeaf` in class `NodePointer`
    Returns:
      boolean

  - ### setPropertyIndex

    public void setPropertyIndex(int index)
    Sets the property index.
    Parameters:
      `index` - property index

  - ### setPropertyName

    public abstract void setPropertyName(String propertyName)
    Sets the property name.
    Parameters:
      `propertyName` - property name to set.